<template>
  <div class="row">
    <div class="col-md-4 mb-1" v-for="song in songs" :key="song.id">
      <router-link :to="`/songs/${song.id}`">
        <el-card shadow="hover">
          <div class="row">
            <div class="col-12">
              <h2 class="h4">{{song.name}}</h2>
            </div>
            <div class="col-12">
              <el-tag type="info" size="mini" v-for="cat in song.category_names" :key="cat">{{cat}}</el-tag>
            </div>
          </div>
          <read-more more-str="" :text="song.content" :max-chars="100"></read-more>
        </el-card>
      </router-link>
    </div>
  </div>

</template>

<script>
    import Requester from "@/controllers/requests/song.js";

    const requester = new Requester();
    export default {
        name: "SongList",
        data() {
            return {
                sortBy: "id",
                songs: [],
                inputSongs: [],
                filterCategoryID: Number,
                filterListID: Number,
            }
        },
        created() {
            this.getAllSongs();
        },
        mounted() {
            this.$root.$on("sortByCategory", (categoryID) => {
                this.filterCategoryID = categoryID;
            });
            this.$root.$on("sortByList", (listID) => {
                this.filterListID = listID;
            });
        },
        methods: {
            getAllSongs() {
                requester.getAllSongs().then(result => {
                    this.inputSongs = result;
                    for (let item of this.inputSongs) {
                        item.category_ids = [];
                        item.list_ids = [];
                        item.category_names = [];
                        for (let category of item.category) {
                            item.category_ids.push(category.id);
                            item.category_names.push(category.name);
                        }
                        for (let list of item.list) {
                            item.list_ids.push(list.id);
                        }
                    }
                    this.songs = this.inputSongs;
                });
            },
            linkToDetailOfSong(item) {
                this.$router.push({
                    name: 'Detail',
                    params: {
                        id: item.id
                    }
                })
            }
        },
        watch: {
            filterCategoryID(val) {
                this.songs = val !== -1
                    ? this.inputSongs.filter(f => {
                        if (f.category_ids.includes(val)) {
                            return f;
                        }
                    })
                    : this.inputSongs;
            },
            filterListID(val) {
                this.songs = val !== -1
                    ? this.inputSongs.filter(f => {
                        if (f.list_ids.includes(val)) {
                            return f;
                        }
                    })
                    : this.inputSongs;
            }
        }
    }
</script>

<style scoped>

</style>
